#include <stdio.h>
#include "z80-cpu.h"
#include "mini-display.h"
#include "keyboard.h"
#include "asm_interface.h"
#include "memory.h"

#define TICS_PORT  (TICS_MEMO+TICS_WAIT)

static  FILE  *ports;

static int fd_out;
static int fd_in;


int
init_ports(void)
{
   char  buffer[256];
   fd_out=fileno(stdout);
   fd_in=fileno(stdin);
   ports= fopen(Z80_PORTS,"r+b");   /* read_writable_binary file */
   if (ports)
      if (256 != fread(buffer,1,256,ports))
      {  fclose(ports), ports= (FILE*)0;  }
   return !ports;
}


void
out_byte(unsigned char id, unsigned char data)
{
   ADDRESS = (ADDRESS&~255) | id;
   DATA= data;
   set_cpu_pin(wr,1);
   set_cpu_pin(iorq,1);
   if (id == fd_out)
      display_in_line(data);
   else if (ports)
   {  int i=fseek(ports,(long)id,SEEK_SET);
      if (i || 1 != fwrite(&data,1,1,ports))
         error(i,"hardware malfunction","port write:");
      fflush(ports);
      if (i=bank_port(id))
         switch_bank(data,i);
   }
   if (!cpu_pin[wait])  wait_tics(TICS_PORT);
   set_cpu_pin(iorq,0);
   set_cpu_pin(wr,0);
}

void
in_byte(unsigned char id, unsigned char *data)
{
   ADDRESS = (ADDRESS&~255) | id;
   set_cpu_pin(rd,1);
   set_cpu_pin(iorq,1);
   if (id == fd_in)
      keystrobe(data);
   else if (ports)
   {  int  i;  fflush(ports);
      i=fseek(ports,(long)id,SEEK_SET);
      if (i || 1 != fread(data,1,1,ports))
         error(i,"hardware malfunction","port read:");
   }
   if (!cpu_pin[wait])  wait_tics(TICS_PORT);
   DATA= *data;
   set_cpu_pin(iorq,0);
   set_cpu_pin(rd,0);
}
