#include "z80-global"
#ifdef  FURTHER_HARDWARE
#include "hardware/quartz.h"
#ifdef  Z80_CTC
#include "hardware/z80-ctc.h"
#endif
#endif

_uchar F,A,B,C,D,E,H,L;
_uchar F_,A_,B_,C_,D_,E_,H_,L_;
_uchar IXl,IXh,IYl,IYh;
_uchar I,R, IM;
_ushort PC,SP,IX,IY;
_uchar DATA; /* data pins */
_ushort ADDRESS; /* address pins */
bit IFF0, IFF1,IFF2, IFF3;  /* internal EI-flipflop & interrupt flip flops */
enum cpu_control_pin { rd, wr, iorq, mreq, m1, rfsh, halt, wait, inter, reset,
                       busrq, busack };
bit cpu_pin[NO_CPU_CONTROL_PINS];


unsigned long ticks;  /* cycle counter attached to CPU */


void set_tics(unsigned long t)
{  ticks=t;
}


void wait_tics(unsigned duration)
{
   while (duration)
   { /* ONE TIC OCCURS */
#ifdef  FURTHER_HARDWARE
     clock_oscillator();
#endif
     duration--;
     ticks++;
   }
}


void  set_cpu_pin(unsigned p, bit level)
{
   if (p >= NO_CPU_CONTROL_PINS)
      return;
   cpu_pin[p]= level;
#ifdef  Z80_CTC
   if (p == m1)
      set_ctc_pin(ctc_m1,level);
   if (p == reset)
      set_ctc_pin(ctc_reset,level);
   if (p == iorq  &&  cpu_pin[wr]  &&  is_ctc_port(ADDRESS&255) )
      set_ctc_pin(ctc_rd,!level);
#endif
}
