#include "z80-global"

#ifndef __Z80CPU
#define __Z80CPU

extern _uchar F,A,B,C,D,E,H,L;
extern _uchar F_,A_,B_,C_,D_,E_,H_,L_;
extern _uchar IXl,IXh,IYl,IYh;
extern _uchar I,R,IM;
extern _ushort PC,SP,IX,IY;
extern _uchar DATA;
extern _ushort ADDRESS;
extern bit  IFF0;      /* internal EI-flipflop */
extern bit  IFF1,IFF2;
extern bit  IFF3;      /* NMI has occured */

/*************************
   rd       cpu wants to read data
   wr       cpu wants to write data
   iorq     cpu signals to access external IO
   mreq     cpu signals to access memory 
   m1       machine cycle one (opcode fetch)
   halt     cpu in halt instruction
   wait     cpu in wait state
   inter    maskable interrupt pending
   reset    cpu reset requested
   busrq    external hardware requests bus control
   busack   cpu acknowledges bus control
   rfsh     cpu signals memory refresh (if mreq is set)
*********************/
enum cpu_control_pin { rd, wr, iorq, mreq, m1, rfsh, halt, wait, inter, reset,
                       busrq, busack };
extern bit cpu_pin[NO_CPU_CONTROL_PINS];

extern void  set_cpu_pin(unsigned p, bit level);
extern const unsigned long ticks;
extern void wait_tics(unsigned duration);
extern void set_tics(unsigned long t);

#endif
